#ifndef MYEQUATION_H
#define MYEQUATION_H

#include <equation.h>
#include <paramfile.h>
#include <filescanner.h>


using namespace Gascoigne;


class MyData
{
public:
  double eps0;

  void BasicInit(const ParamFile & pf)
  {
    DataFormatHandler DFH;
    DFH.insert("eps0", &eps0, 1.);
    FileScanner FS(DFH, pf, "Equation");
  }
};


class MyEquation : public virtual Equation
{

private:

  MyData data;

public:

  MyEquation(const MyData &PD) : data(PD) { }

  MyEquation* createNew() const
  {
    return new MyEquation(data);
  }


  std::string GetName() const { return "ConvDiff"; }

  int GetNcomp() const {return 1;}

  void Form(VectorIterator b,
            const FemFunction &U,
            const TestFunction &N) const;

  void Matrix(EntryMatrix &A,
              const FemFunction &U,
              const TestFunction &M,
              const TestFunction &N) const;

  void point(double h, const FemFunction &U, const Vertex2d &v) const;
};


#endif /* MYEQUATION_H */
